<?php
/**
* @category     Addons
 * @package      page module: faqbaker
 * @copyright    Uwe Jacobsen <webdesign@jacobi22.com>
 * @author       Uwe Jacobsen <webdesign@jacobi22.com>
 * @license      http://www.gnu.org/licenses/gpl.html   GPL License
 * @version      2.2.0
 * @lastmodified $Date: 2023/03/09
 * @since        File available since 2023/03/09
 * @description  addon faqbaker
 *
 * ajax.php
 * 
 */

    $aJsonRespond = [];
    $sModuleDir   = basename(dirname(__DIR__));
    // require config for Constants and DB access
    require(dirname(dirname(dirname(__DIR__))).'/config.php');
    // Check if user has enough rights to do this:
    // initialize json_respond array  (will be sent back)
    try{
        if (!class_exists('admin', false)){require(WB_PATH.'/framework/class.admin.php');}
        $admin = new admin('Modules', 'module_view', FALSE, FALSE);
    // first read and validate the $_POST arguments
        $aAllowedActions = ['updateCatPosition','updateQuestPosition','updateTemplatePosition','toggle_cat_active_status','toggle_quest_active_status','toggle_template_active_status', 'delete_cat','delete_quest','delete_template'];
        $sRequestAction  = $_POST['action'] ?:'';
        // test if action value is in allowed list of actions
        if ( !in_array($sRequestAction, $aAllowedActions)) {
            throw new Exception('no valid action was set');
        }
        if($sRequestAction == 'updateCatPosition'){
            $iRequestRecordId = $_POST['iRecordCatId'];
        }elseif($sRequestAction == 'updateQuestPosition'){
            $iRequestRecordId = $_POST['iRecordQuestId'];
        }else{
            $iRequestRecordId = $_POST['iRecordId'];
        }
        $iRecordID = '';
        if (!($admin->is_authenticated() && $admin->get_permission($sModuleDir, 'module'))) {
            throw new Exception('You\'re not allowed to make changes to Module: ['.$sModuleDir.']');
        }
        switch ($sRequestAction):
            case 'updateCatPosition':
                $i = 1;
                foreach ($_POST['iRecordCatId'] as $iRecordID) {
                    //$iIdKey = $admin->checkIDKEY($iRecordID, false, 'POST');
                    // update database
                    $sql = 'UPDATE `'.TABLE_PREFIX.'mod_faq_categories` SET '
                        .  '`position`='.$i.' '
                        . 'WHERE `cat_id`='.$iRecordID;
                    if (!(bool)$database->query($sql)) {
                        throw new Exception('DB access fail ['.$database->get_error().']');
                        $aJsonRespond['icon'] = 'stop.png';
                    }
                    $i++;
                } 
                $aJsonRespond['icon'] = 'success.png';
                $message = 'updateCat '.$iRecordID;
            break;
            case 'updateQuestPosition':
                $i = 1;
                //$aGroupsArray = $sRequestIdKey;
                foreach ($_POST['iRecordQuestId'] as $iRecordID) {
                    #$iIdKey = $admin->checkIDKEY($iRecordID, false, 'POST');
                    // update database
                    $sql = 'UPDATE `'.TABLE_PREFIX.'mod_faq_questions` SET '
                        .  '`position`='.$i.' '
                        . 'WHERE `question_id`='.$iRecordID;
                    if (!(bool)$database->query($sql)) {
                        throw new Exception('DB access fail ['.$database->get_error().']');
                        $aJsonRespond['icon'] = 'stop.png';
                    }
                    $i++;$message = 'updateQuestion '.$iRecordID;
                } 
                $aJsonRespond['icon'] = 'success.png';
                $message = 'updateQuestion '.$iRecordID;
            break;
            case 'updateTemplatePosition':
                $i = 1;
                //$aGroupsArray = $sRequestIdKey;
                foreach ($_POST['iRecordId'] as $iRecordID) {
                    //$iIdKey = $admin->checkIDKEY('iRecordId', false, 'POST');
                    // update database
                    $sql = 'UPDATE `'.TABLE_PREFIX.'mod_wbbookmarks_templates` SET '
                        .  '`position`='.$i.' '
                        . 'WHERE `template_id`='.$iRecordID;
                    if (!(bool)$database->query($sql)) {
                        throw new Exception('DB access fail ['.$database->get_error().']');
                        $aJsonRespond['icon'] = 'stop.png';
                    }
                    
                    $i++;
                } 
                $aJsonRespond['icon'] = 'success.png';
                $message = 'updateTemplate '.$iRecordID;
            break;
            case 'toggle_cat_active_status':
                $iIdKey = $admin->checkIDKEY('iRecordId', false, 'POST');
                $sql = 'UPDATE `'.TABLE_PREFIX.'mod_faq_categories` SET '
                     . '`active`= (`active` IS NOT TRUE) '
                     . 'WHERE `cat_id`='.$iIdKey;
//                throw new Exception('SQL:'.$sql);
                if (!(bool)$database->query($sql)) {
                    throw new Exception('DB access fail ['.$database->get_error().']');
                    $aJsonRespond['icon'] = 'stop.png';
                }
                $aJsonRespond['icon'] = 'success.png';
                $message = 'toogleCategory '.$iIdKey;
            break;
            case 'toggle_quest_active_status':
                $iIdKey = $admin->checkIDKEY('iRecordId', false, 'POST');
                $sql = 'UPDATE `'.TABLE_PREFIX.'mod_faq_questions` SET '
                     . '`active`= (`active` IS NOT TRUE) '
                     . 'WHERE `question_id`='.$iIdKey;
                if (!(bool)$database->query($sql)) {
                    throw new Exception('DB access fail ['.$database->get_error().']');
                    $aJsonRespond['icon'] = 'stop.png';
                }
                $aJsonRespond['icon'] = 'success.png';
                $message = 'toogleQuestion '.$iIdKey;
            break;
            case 'toggle_template_active_status':
                $iIdKey = $admin->checkIDKEY('iRecordId', false, 'POST');
                $sql = 'UPDATE `'.TABLE_PREFIX.'mod_faq_templates` SET '
                     . '`active`= (`active` IS NOT TRUE) '
                     . 'WHERE `template_id`='.$iIdKey;
                if (!(bool)$database->query($sql)) {
                    throw new Exception('DB access fail ['.$database->get_error().']');
                    $aJsonRespond['icon'] = 'stop.png';
                }
                $aJsonRespond['icon'] = 'success.png';
                $message = 'toggleTemplate '.$iIdKey;
            break;
            case 'delete_cat':
                $iIdKey = $admin->checkIDKEY('iRecordId', false, 'POST');
                $sql = 'DELETE FROM `'.TABLE_PREFIX.'mod_faq_questions` '
                     . 'WHERE `cat_id`='.$iIdKey;
                if (!(bool)$database->query($sql)) {
                    throw new Exception('DB access fail ['.$database->get_error().']');
                }
                $sql = 'DELETE FROM `'.TABLE_PREFIX.'mod_faq_categories` '
                     . 'WHERE `cat_id`='.$iIdKey;
                if (!(bool)$database->query($sql)) {
                    throw new Exception('DB access fail ['.$database->get_error().']');
                    $aJsonRespond['icon'] = 'stop.png';
                }
                $aJsonRespond['icon'] = 'success.png';
                $message = 'deleteCategory '.$iIdKey;
            break;
            case 'delete_quest':
                $iIdKey = $admin->checkIDKEY('iRecordId', false, 'POST');
                $sql = 'DELETE FROM `'.TABLE_PREFIX.'mod_faq_questions` '
                     . 'WHERE `question_id`='.$iIdKey;
                if (!(bool)$database->query($sql)) {
                    throw new Exception('DB access fail ['.$database->get_error().']');
                    $aJsonRespond['icon'] = 'stop.png';
                }
                $aJsonRespond['icon'] = 'success.png';
                $message = 'deleteQuestion '.$iIdKey;
            break;
            case 'delete_template':
                $iIdKey = $admin->checkIDKEY('iRecordId', false, 'POST');
                $sql = 'DELETE FROM `'.TABLE_PREFIX.'mod_faq_templates` '
                     . 'WHERE `template_id`='.$iIdKey;
                if (!(bool)$database->query($sql)) {
                    throw new Exception('DB access fail ['.$database->get_error().']');
                    $aJsonRespond['icon'] = 'stop.png';
                }
                $aJsonRespond['icon'] = 'success.png';
                $message = 'deleteTemplate '.$iIdKey;
            break;
            
            default:
                throw new Exception('no valid "action" was set ');
                break;
        endswitch;
        
        $aJsonRespond['success'] = true;
//        $aJsonRespond['sIdKey']  = $admin->getIDKEY($iIdKey);
        //$aJsonRespond['sIdKey']  = $iIdKey;
        $aJsonRespond['message'] = $message;
    } catch (Exception $e) {
        $aJsonRespond['message'] = $e->getMessage();
        $aJsonRespond['success'] = false;
        //$aJsonRespond['sIdKey']  = $admin->getIDKEY($iIdKey);
        //$aJsonRespond['sIdKey']  = $iIdKey;
    }
    // echo the json_respond to the ajax function
    exit(json_encode($aJsonRespond));
