/**
 * @category     Addons
 * @package      page module: faqbaker
 * @copyright    Uwe Jacobsen <webdesign@jacobi22.com>, and others (see CHANGELOG)
 * @author       Uwe Jacobsen <webdesign@jacobi22.com>, and others (see CHANGELOG)
 * @license      http://www.gnu.org/licenses/gpl.html   GPL License
 * @version      1.0.0
 * @since        File available since 2017/11/23
 * @description  addon faqbaker
 * file..........ajaxDeleteRecord.js
*/

(function($) {
    $.fn.ajaxDeleteRecord = function(options) {
        
        var aOpts = $.extend({}, $.fn.ajaxDeleteRecord.defaults, options);        
        $(this).find('a').removeAttr("href").css('cursor', 'pointer');
        
        $(this).click(function() {
            var oLink = $(this).find('a');
            var oElement = $(this).find('img');
            var iRecordId = oElement.attr("id").substring(7);
            var oRecord = $("div#" + 'delete_' + iRecordId);
            
            // pregenerate the data string
            var sDataString = 'action='+aOpts.ACTION+'&iRecordId='+iRecordId;

            if (confirm(LANG.SURE_DELETE_RECORD)) {                    

                $.ajax({
                    url: FAQBAKER.AJAX_PLUGINS +'/ajax.php',
                    type: "POST",
                    dataType: 'json',
                    data: sDataString,
                    success: function(json_respond) {
                        if(json_respond.success === true) {
                            oRecord.attr("id", json_respond.sIdKey);
                            oElement.attr("id", "delete_"+ json_respond.sIdKey);
                            oElement.attr("src", FAQBAKER.ICONS + "/delete_16.png");
                            oElement.animate({opacity: 1});
                            var INFO_BOX = jQuery("#" + RESULTS_CONTAINER);
                            INFO_BOX.html('<span id="alertFadeOut"> <img id="reload_img" src="'+ FAQBAKER.ICONS +'/' + json_respond.icon +'" alt="" /> ' + LANG.DELETE_ITEM + '</span>').fadeIn("slow");
                            jQuery("#alertFadeOut").fadeOut(1000);
                            window.location.reload();
                        } else {
                            oRecord.attr("id", json_respond.sIdKey);
                            oElement.attr("id", "delete_"+ json_respond.sIdKey);
                            alert(json_respond.message);
                        }
                    }
            });
            }
        });
    }    
})(jQuery);
