/*
 * @category     Addons
 * @package      page module: faqbaker
 * @copyright    Uwe Jacobsen <webdesign@jacobi22.com>, and others (see CHANGELOG)
 * @author       Uwe Jacobsen <webdesign@jacobi22.com>, and others (see CHANGELOG)
 * @license      http://www.gnu.org/licenses/gpl.html   GPL License
 * @version      1.0.0
 * @since        File available since 2017/11/23
 * @description  addon faqbaker
 * https://jqueryui.com/draggable/#sortable
*/
// **********************************************************************************


if(!jQuery().sortable){             
    jQuery.insert(WB_URL+"/include/jquery/jquery-ui-min.js");
    
}    
            
if(jQuery().sortable){

    jQuery(function() { 
        
        jQuery('.dragdrop_CatItem').addClass('dragdrop_handle');
        jQuery(".dragdrop_Cat ul").sortable({ 
            appendTo:      'body',
            handle:        '.dragdrop_handle',
            opacity:       0.8, 
            cursor:        'move', 
            delay:         100,
            placeholder:   "highlight",
            items:         'li',
            dropOnEmpty: false,
            update: function() {
                jQuery.ajax({
                    type:        'POST',
                    url:         FAQBAKER.AJAX_PLUGINS +'/ajax.php', 
                    data:        jQuery(this).sortable("serialize", { 
                                     expression: /(.+)[:=](.+)/
                                 }) + '&action=updateCatPosition', 
                    dataType:     'json',
                    success:    function(json_respond){
                        if( json_respond.success != true ) {
                            alert(json_respond.message);
                        }
                        var INFO_BOX = jQuery("#" + RESULTS_CONTAINER);
                        INFO_BOX.html('<span id="alertFadeOut"> <img id="reload_img" src="'+ FAQBAKER.ICONS +'/' + json_respond.icon +'" alt="" /> ' + LANG.CHANGE_ITEM_POSITION + '</span>').fadeIn("slow");
                        jQuery("#alertFadeOut").fadeOut(3000);
                        // due to expiring IDKEYs we have to refresh the page
                         window.location.reload();
                    }
                });     
            }
        })
    });

   jQuery(function() { 
        
        jQuery('.dragdrop_QuestItem').addClass('dragdrop_handle');
        jQuery(".dragdrop_Quest ul").sortable({ 
            appendTo:      'body',
            handle:        '.dragdrop_handle',
            opacity:       0.8, 
            cursor:        'move', 
            delay:         100,
            placeholder:   "highlight",
            items:         'li',
            dropOnEmpty: false,
            update: function() {
                jQuery.ajax({
                    type:        'POST',
                    url:         FAQBAKER.AJAX_PLUGINS +'/ajax.php', 
                    data:        jQuery(this).sortable("serialize", { 
                                     expression: /(.+)[:=](.+)/
                                 }) + '&action=updateQuestPosition', 
                    dataType:     'json',
                    success:    function(json_respond){
                        if( json_respond.success != true ) {
                            alert(json_respond.message);
                        }
                        var INFO_BOX = jQuery("#" + RESULTS_CONTAINER);
                        INFO_BOX.html('<span id="alertFadeOut"> <img id="reload_img" src="'+ FAQBAKER.ICONS +'/' + json_respond.icon +'" alt="" /> ' + LANG.CHANGE_ITEM_POSITION + '</span>').fadeIn("slow");
                        jQuery("#alertFadeOut").fadeOut(3000);
                        // due to expiring IDKEYs we have to refresh the page
//                         window.location.reload();   
                    }
                });     
            }                    
        })
    });      
    jQuery(function() { 
        
        jQuery('.dragdrop_TemplateItem').addClass('dragdrop_handle'); 
        
        jQuery(".dragdrop_Template ul").sortable({ 
            appendTo:      'body',
            handle:        '.dragdrop_handle',
            opacity:       0.8, 
            cursor:        'move', 
            delay:         100,
            placeholder:   "highlight",
            items:         'li',
            dropOnEmpty: false,
            
            update: function() {
                jQuery.ajax({
                    type:        'POST',
                    url:         FAQBAKER.AJAX_PLUGINS +'/ajax.php', 
                    data:        jQuery(this).sortable("serialize", { 
                                     expression: /(.+)[:=](.+)/
                                 }) + '&action=updateTemplatePosition', 
                    dataType:     'json',
                    success:    function(json_respond){
                        if( json_respond.success != true ) {
                            alert(json_respond.message);
                        }
                        var INFO_BOX = jQuery("#" + RESULTS_CONTAINER);
                        INFO_BOX.html('<span id="alertFadeOut"> <img id="reload_img" src="'+ FAQBAKER.ICONS +'/' + json_respond.icon +'" alt="" /> ' + LANG.CHANGE_ITEM_POSITION + '</span>').fadeIn("slow");
                        jQuery("#alertFadeOut").fadeOut(3000);
                        // due to expiring IDKEYs we have to refresh the page
//                        window.location.reload(); 
                    }
                });     
            }
        })
    });
}//endif
