<?php
/**
* @category     Addons
 * @package      page module: faqbaker
 * @copyright    Uwe Jacobsen <webdesign@jacobi22.com>
 * @author       Uwe Jacobsen <webdesign@jacobi22.com>
 * @license      http://www.gnu.org/licenses/gpl.html   GPL License
 * @version      2.2.0
 * @lastmodified $Date: 2023/03/09
 * @since        File available since 2023/03/09
 * @description  addon faqbaker
 *
 * AddNewQuest.inc.php
*/
//            echo "<pre>POST in AddNewQuest.inc.php:<br>";
//            print_r($_POST);
//            echo "</pre>";
use addon\faqbaker\Lib\Faqbaker;
use bin\{WbAdaptor, SecureTokens};
use bin\helpers\{PreCheck};

use Twig\Loader\FilesystemLoader;
use Twig\Environment;
use Twig\TwigFilter;
/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 Not Found'; \flush(); exit;}
/* -------------------------------------------------------- */
$iActualSectionID = $oRequest->getParam('section_id');
if ($iActualSectionID == $section_id){
//load some initial datas
    if (is_readable($sAddonPath.'/init.php'))     {require ($sAddonPath.'/init.php');}
    // secure check - correct FTAN?

    $oTrans->enableAddon('modules\\'.$sAddonName);
    
    // back to the module overview
    $sec_anchor = (defined( 'SEC_ANCHOR' ) && ( SEC_ANCHOR != '' )  ? '#'.SEC_ANCHOR.$section_id : '' );
    $sAddonBackUrl = ADMIN_URL.'/pages/modify.php?page_id='.(int)$page_id;
    if (!function_exists('xnl2br')){require(WB_PATH.'/framework/functions.php');}
    
    if (!\bin\SecureTokens::checkFTAN ()) {
        throw new \Exception ($oTrans->MESSAGE_GENERIC_SECURITY_ACCESS);
    }    
    $iSelectedCatId = $admin->checkIDKEY('selectedCatId', false,'POST');

    if($iSelectedCatId === false ) {
        $aMessage = \sprintf("%s\n","AddNewQuestion - Missing IDKey ".$oTrans->MESSAGE_GENERIC_SECURITY_ACCESS);
        $admin->print_error($aMessage, $sAddonBackUrl );
    }
    
    $aFtan = SecureTokens::getFTAN();
    $sActualUserID = $admin->getUserId();
    $sActualDisplayName = $database->get_one('SELECT `display_name` FROM `'.TABLE_PREFIX.'users` WHERE `user_id` = '.(int)$sActualUserID.' ');
    $timestamp = time()+TIMEZONE;
    $sLanguage = LANGUAGE;
    
    // wysiwyg editor    
    $content = '';
    $name = 'answer';
    if (!isset($wysiwyg_editor_loaded)) {
        $wysiwyg_editor_loaded=true;
        if (!\defined('WYSIWYG_EDITOR') OR WYSIWYG_EDITOR=="none" || !\file_exists(WB_PATH.'/modules/'.WYSIWYG_EDITOR.'/include.php')) {
            function show_wysiwyg_editor($name,$id,$content,$width,$height) {
                echo '<textarea name="'.$name.'" id="'.$id.'" style="width: '.$width.'; height: '.$height.';">'.$content.'</textarea>';
            }
        } else {
            $sTableName = 'mod_faq_categories';
            $id_list = [];
            require(WB_PATH.'/modules/'.WYSIWYG_EDITOR.'/include.php');
        }
    }
    ob_start();     // start output buffer
    show_wysiwyg_editor('answer','answer',$content,'100%','258px',"utf8mb4");
    $show_editor=ob_get_contents();
    ob_end_clean();

    // complete array with replacements
    $aTplDefaults = array(
            'WB_URL'               => WB_URL,
            'WB_PATH'              => WB_PATH,
            'MODULE_THEME_URL'     => $sAddonThemeUrl,
            'MODULE_THEME_PATH'    => $sAddonThemePath,
            'ICON_URL'             => $sAddonThemeUrl.'/images',
            'ADDON_NAME'           => strtolower($sAddonName),
            'ADDONNAME'            => strtoupper($sAddonName),
            'ADDONURL'             => $sAddonUrl,
            'LANGUAGE'             => LANGUAGE,
            'PAGE_ID'              => $page_id,
            'SECTION_ID'           => $section_id,
            'FTAN_NAME'            => $aFtan['name'],
            'FTAN_VALUE'           => $aFtan['value'],
            'WYSIWYG_EDITOR'       => WYSIWYG_EDITOR,
            'LANGUAGE'             => LANGUAGE,
            'LANGUAGE_LW'          => \strtolower($sLanguage),
            'ICON_URL'             => $sAddonThemeUrl.'/images',
            'THEME_URL'            => $sAddonThemeUrl,
            'MODIFY_URL'           => ADMIN_URL.'/pages/modify.php?page_id='.(int)$page_id,
            'SAVE_URL'             => ADMIN_URL.'/pages/save.php',
            'CANCEL_URL'           => $sAddonBackUrl,
            'EDITTEMPLATE'         => $admin->getIDKEY('EditTempl'),
            'EDITORID'             => $sActualUserID,
            'EDITORNAME'           => $sActualDisplayName,
            'ACTUALDATE'           => date('d.m.Y',$timestamp),
            'ACTUALTIME'           => date ('H:i',$timestamp),
            'MYEDITOR'             => $show_editor,
        );

    $aTwigdata = $aTplDefaults;
     
    $oBEFunctions = new Faqbaker();
    //settings
    $aTwigdata['setting']                       = $oBEFunctions->getFaqbakerSettings($section_id);
    $aTwigdata['CatList']                       = $oBEFunctions->getFAQAllCatsArray($section_id);
    $aTwigdata['AddToCatID']                    = $iSelectedCatId;
    $aTwigdata['lang']                          = $oTrans->getLangArray();
    
    if (is_readable($sAddonThemePath.'/AddNewQuestion.twig'))
        {
            // create twig template object
            $loader = new \Twig\Loader\FilesystemLoader($sAddonThemePath);
            $oTwig  = new \Twig\Environment($loader, [
                'autoescape'       => false,
                'cache'            => false,
                'strict_variables' => false,
                'debug'            => false,
                'auto_reload'      => true,
            ]);
            
            $oTwig->addFilter(new TwigFilter('strftime', 'strftime_filter'));
            $oTwig->addFilter(new TwigFilter('var_dump','var_dump'));
            echo $oTwig->render('AddNewQuestion.twig', $aTwigdata);
        }

}else{
    echo $oTrans['FQTEXT_INACTIVE_SECTION']."<br>";
}
// end of file
