<?php
/**
* @category     Addons
 * @package      page module: faqbaker
 * @copyright    Uwe Jacobsen <webdesign@jacobi22.com>
 * @author       Uwe Jacobsen <webdesign@jacobi22.com>
 * @license      http://www.gnu.org/licenses/gpl.html   GPL License
 * @version      2.2.0
 * @lastmodified $Date: 2023/03/09
 * @since        File available since 2023/03/09
 * @description  addon faqbaker
 *
 * cmdAddtemplate.inc
/* -------------------------------------------------------- */
//            echo "<pre>";
//            print_r($_POST);
//            echo "</pre>";

use bin\{WbAdaptor, SecureTokens};
use bin\helpers\{PreCheck};

/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 Not Found'; \flush(); exit;}
/* -------------------------------------------------------- */
    $bExcecuteCommand = ($bExcecuteCommand ?? true);
    $oReg     = WbAdaptor::getInstance();
    $oRequest = $oReg->getRequester();
    $oDb      = $oReg->getDatabase();
    $oTrans   = $oReg->getTranslate();
    $oApp     = ($oReg->getApplication() ?? null);

//load some initial datas
if (is_readable($sAddonPath.'/init.php'))     {require ($sAddonPath.'/init.php');}

$oTrans->enableAddon('modules\\'.$sAddonName);
require_once $sAddonPath.'/lib/class.Faqbaker.php';

    // back to the module overview
    $sec_anchor = (defined( 'SEC_ANCHOR' ) && ( SEC_ANCHOR != '' )  ? '#'.SEC_ANCHOR.$section_id : '' );
    $sAddonBackUrl = ADMIN_URL.'/pages/modify.php?page_id='.(int)$page_id;
    if (!function_exists('xnl2br')){require(WB_PATH.'/framework/functions.php');}

    // secure check - correct FTAN?
    if (!\bin\SecureTokens::checkFTAN ()) {
        $aMessage = \sprintf("%s\n"," AddTemplate - Missing FTAN ".$oTrans->MESSAGE_GENERIC_SECURITY_ACCESS);
        $admin->print_error($aMessage, $sAddonBackUrl );
    }
    
    if (!function_exists('loader_help')){require(WB_PATH.'/include/editarea/wb_wrapper_edit_area.php');}
    

    
    // complete array with replacements
    $aTplDefaults = array(
            'WB_URL' => WB_URL,
            'WB_PATH' => WB_PATH,
            'MODULE_THEME_URL'     => $sAddonThemeUrl,
            'MODULE_THEME_PATH'    => $sAddonThemePath,
            'ICON_URL'             => $sAddonThemeUrl.'/images',
            'ADDON_NAME'           => strtolower($sAddonName),
            'ADDONNAME'            => strtoupper($sAddonName),
            'ADDONURL'             => $sAddonUrl,
            'LANGUAGE'             => LANGUAGE,
            'PAGE_ID'              => $page_id,
            'SECTION_ID'           => $section_id,
            'FTAN'                 => $admin->getFTAN(),
            'FTAN_NAME'            => $FTAN['name'],
            'FTAN_VALUE'           => $FTAN['value'],
            'LANGUAGE'             => LANGUAGE,
            'ICON_URL'             => $sAddonThemeUrl.'/images',
            'THEME_URL'            => $sAddonThemeUrl,
            'MODIFY_URL'           => ADMIN_URL.'/pages/modify.php',
            'SAVE_URL'             => ADMIN_URL.'/pages/save.php',
            'CANCEL_URL'           => $sAddonBackUrl,
            'EDITTEMPLATE'         => $admin->getIDKEY('EditTempl'),
        );

    $aTwigdata = $aTplDefaults;
    $oBEFunctions = new Faqbaker();
    //settings
    $aTwigdata['setting']                       = $oBEFunctions->getFaqbakerSettings($section_id);
    $aTwigdata['lang']                              = $oTrans->getLangArray();
    //    $aTwigdata['templates'] = getTemplateDetailArray($section_id,$iTemplateId);
    // load TWIG-template
    if (version_compare($sWbVersion, '2.13.0', '>=')){
        if (is_readable($sAddonThemePath.'/AddTemplate.twig'))
            {
                // create twig template object
                $loader = new \Twig\Loader\FilesystemLoader($sAddonThemePath);
                $oTwig  = new \Twig\Environment($loader, [
                    'autoescape'       => false,
                    'cache'            => false,
                    'strict_variables' => false,
                    'debug'            => false,
                    'auto_reload'      => true,
                ]);
                
                $oTwig->addFilter(new TwigFilter('strftime', 'strftime_filter'));
                $oTwig->addFilter(new TwigFilter('var_dump','var_dump'));
                echo $oTwig->render('AddTemplate.twig', $aTwigdata);
            }
    }
// end of file
