<?php
/**
 * @category     Addons
 * @package      page module: faqbaker
 * @copyright    Uwe Jacobsen <webdesign@jacobi22.com>
 * @author       Uwe Jacobsen <webdesign@jacobi22.com>
 * @license      http://www.gnu.org/licenses/gpl.html   GPL License
 * @version      2.2.0
 * @lastmodified $Date: 2023/03/09
 * @since        File available since 2023/03/09
 * @description  addon faqbaker
 *
 * Modify.inc.php
/* -------------------------------------------------------- */
//            echo "<pre>POST in Modify.inc.php:<br>";
//            print_r($_POST);
//            echo "</pre>";
// 
use addon\faqbaker\Lib\Faqbaker;
use bin\{WbAdaptor, SecureTokens};
use bin\helpers\{PreCheck};

use Twig\Loader\FilesystemLoader;
use Twig\Environment;
use Twig\TwigFilter;
/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 Not Found'; \flush(); exit;}
/* -------------------------------------------------------- */


//load some initial datas
if (is_readable($sAddonPath.'/init.php'))     {require ($sAddonPath.'/init.php');}

$oTrans->enableAddon('modules\\'.$sAddonName);

// back to the module overview
$sec_anchor = '#'.(\defined('SEC_ANCHOR') && !empty(SEC_ANCHOR) ? SEC_ANCHOR : 'Sec' ).(int)$section_id;
$sAddonBackUrl = ADMIN_URL.'/pages/modify.php?page_id='.(int)$page_id.$sec_anchor;

$sLanguage = LANGUAGE;

// wysiwyg editor    
$content = '';
$name = 'cat_desc';
if (!isset($wysiwyg_editor_loaded)) {
    $wysiwyg_editor_loaded=true;
    if (!\defined('WYSIWYG_EDITOR') OR WYSIWYG_EDITOR=="none" || !\file_exists(WB_PATH.'/modules/'.WYSIWYG_EDITOR.'/include.php')) {
        function show_wysiwyg_editor($name,$id,$content,$width,$height) {
            echo '<textarea name="'.$name.'" id="'.$id.'" style="width: '.$width.'; height: '.$height.';">'.$content.'</textarea>';
        }
    } else {
        $sTableName = 'mod_faq_categories';
        $id_list = [];
        require(WB_PATH.'/modules/'.WYSIWYG_EDITOR.'/include.php');
    }
}
ob_start();     // start output buffer
show_wysiwyg_editor('cat_desc','cat_desc',$content,'100%','258px',"utf8mb4");
$show_editor=ob_get_contents();
ob_end_clean();

$aFtan = SecureTokens::getFTAN();
// complete array with replacements
$aTplDefaults = array(
    'WB_URL' => WB_URL,
    'MODULE_THEME_URL'     => $sAddonThemeUrl,
    'MODULE_THEME_PATH'    => $sAddonThemePath,
    'ICON_URL'             => $sAddonThemeUrl.'/images',
    'ADDON_NAME'           => strtolower($sAddonName),
    'ADDONNAME'            => strtoupper($sAddonName),
    'ADDONURL'             => $sAddonUrl,
    'PAGE_ID'              => $page_id,
    'SECTION_ID'           => $section_id,
    'FTAN_NAME'            => $aFtan['name'],
    'FTAN_VALUE'           => $aFtan['value'],
    'LANGUAGE'             => LANGUAGE,
    'LANGUAGE_LW'          => \strtolower($sLanguage),
    'ICON_URL'             => $sAddonThemeUrl.'/images',
    'THEME_URL'            => $sAddonThemeUrl,
    'MODIFY_URL'           => ADMIN_URL.'/pages/modify.php?page_id='.(int)$page_id.$sec_anchor,
    'EDIT_URL'             => ADMIN_URL . '/pages/modify.php?page_id=' . (int) $page_id,
    'WYSIWYG_EDITOR'       => WYSIWYG_EDITOR,
    'MODIFY_SETTINGS_LINK' => ADMIN_URL.'/pages/add.php',
    'SAVE_URL'             => ADMIN_URL.'/pages/save.php',
    'CANCEL_URL'           => $sAddonBackUrl,
    'ADDCAT'               => SecureTokens::getIDKEY('AddCat'),
    'ADDQUEST'             => SecureTokens::getIDKEY('AddQuestion'),
    'SETTINGSID'           => SecureTokens::getIDKEY('Settings'),
    'NEW_ADD_ID'           => SecureTokens::getIDKEY('999999'),
    'EDITTEMPLATE'         => SecureTokens::getIDKEY('EditTemplate'),
    'Editor-ID'            => $admin->getUserId(),
    'MYEDITOR'             => $show_editor,
);
$aTwigdata = $aTplDefaults;

if(\is_readable($sAddonPath.'/backend.css')){ $aFilenames[] = 'backend.css';$sCssFilePath = $sAddonPath.'/';}   
if(\is_readable($sAddonPath.'/frontend.css')){ $aFilenames[] = 'frontend.css';$sCssFilePath = $sAddonPath.'/';}
if(\is_readable($sAddonPath.'/backendUser.css')){ $aFilenames[] = 'backendUser.css';$sCssFilePath = $sAddonPath.'/';}
if(\is_readable($sAddonPath.'/frontendUser.css')){ $aFilenames[] = 'frontendUser.css';$sCssFilePath = $sAddonPath.'/';}
if(\is_readable($sAddonThemePath.'/css/backend_default.css')){ $aFilenames[] = 'backend_default.css';$sCssFilePath = $sAddonThemePath.'/css/';}
if(\is_readable($sAddonTemplatePath.'css/frontend_default.css')){ $aFilenames[] = 'frontend_default.css';$sCssFilePath = $sAddonTemplatePath.'css/';}

        foreach ($aFilenames AS $key => $sCssEditFile){
            $sFilename = $sCssEditFile;
            $sFileIdkey[$sCssEditFile]= SecureTokens::getIDKEY($sCssEditFile);
            $aTwigdata['AvaiableCss'] = array(
                'filekey'                         => $sFileIdkey,
            );
        }

$sAddonPath   = str_replace('\\','/',dirname(__DIR__)).'/';
$sTargetPath  = $sAddonPath.'presets/';
$aImportFiles = \glob($sTargetPath.'*.php', GLOB_NOSORT);
sort($aImportFiles);
$aPresetContent = [];
foreach ($aImportFiles as $sPresetFilename) {
    include($sPresetFilename);
    $sFileC['filename']    = $sPresetFilename;
    $sFileC['title']       = $sTemplateTitle;
    $sFileC['description'] = $sTemplateDescription;
    $sFileC['description'] = $FQTEXT[$sFileC['description']];
    $aPresetContent[]      = $sFileC;
}

$oBEFunctions = new Faqbaker();
//settings
$aTwigdata['setting']                           = $oBEFunctions->getFaqbakerSettings($section_id);
$aTwigdata['CountCats']                         = $oBEFunctions->FAQCatEntrys($section_id);
$aTwigdata['CountQuestion']                     = $oBEFunctions->FAQQuestEntrys($section_id);
$aTwigdata['CatSortMode']                       = $oBEFunctions->FAQCatSortMode($section_id);
$iCatOrder                                      = $oBEFunctions->FAQCatSortMode($section_id);
$aTwigdata['QuestSortMode']                     = $oBEFunctions->FAQQuestSortMode($section_id);
$iQuestOrder                                    = $oBEFunctions->FAQQuestSortMode($section_id);
$aTwigdata['GROUPED_CATS']                      = $oBEFunctions->getFAQCatQuestArray($section_id,$iCatOrder,$iQuestOrder);
$aTwigdata['CatList']                           = $oBEFunctions->getFAQAllCatsArray($section_id,$iCatOrder);
$aTwigdata['CountTemplates']                    = $oBEFunctions->getFAQTemplateEntrys($section_id);
$aTwigdata['TemplateList']                      = $oBEFunctions->getFAQAllTemplatesArray($section_id);
$aTwigdata['CatTitles']                         = $oBEFunctions->getFAQAllCatTitles($section_id);
$aTwigdata['PresetList']                        = $aPresetContent;
$aTwigdata['lang']                              = $oTrans->getLangArray();

//            echo "<pre>Modify.inc.php:<br>";
//            print_r($aTwigdata['lang']);
//            echo "</pre>";
//            
    // load TWIG-template
        if (is_readable($sAddonThemePath.'/Modify.twig'))
            {
                // create twig template object
                $loader = new \Twig\Loader\FilesystemLoader($sAddonThemePath);
                $oTwig  = new \Twig\Environment($loader, [
                    'autoescape'       => false,
                    'cache'            => false,
                    'strict_variables' => false,
                    'debug'            => false,
                    'auto_reload'      => true,
                ]);
                
                $oTwig->addFilter(new TwigFilter('strftime', 'strftime_filter'));
                $oTwig->addFilter(new TwigFilter('var_dump','var_dump'));
                echo $oTwig->render('Modify.twig', $aTwigdata);
            }

// end of file
