<?php
/**
* @category     Addons
 * @package      page module: faqbaker
 * @copyright    Uwe Jacobsen <webdesign@jacobi22.com>
 * @author       Uwe Jacobsen <webdesign@jacobi22.com>
 * @license      http://www.gnu.org/licenses/gpl.html   GPL License
 * @version      2.2.0
 * @lastmodified $Date: 2023/03/09
 * @since        File available since 2023/03/09
 * @description  addon faqbaker
 *
 * ModifySettings.inc.php
/* -------------------------------------------------------- */
//            echo "<pre>POST in ModifySettings.inc.php:<br>";
//            print_r($_POST);
//            echo "</pre>";
//
use addon\faqbaker\Lib\Faqbaker;
use bin\{WbAdaptor, SecureTokens};
use bin\helpers\{PreCheck};

use Twig\Loader\FilesystemLoader;
use Twig\Environment;
use Twig\TwigFilter;
/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 Not Found'; \flush(); exit;}
/* -------------------------------------------------------- */

$iActualSectionID = $oRequest->getParam('section_id');
if ($iActualSectionID == $section_id){
    //load some initial datas
    if (is_readable($sAddonPath.'/init.php'))     {require ($sAddonPath.'/init.php');}
    $oTrans->enableAddon('modules\\'.$sAddonName);

    $sAddonBackUrl = ADMIN_URL.'/pages/modify.php?page_id='.(int)$page_id;
    if (!function_exists('xnl2br')){require(WB_PATH.'/framework/functions.php');}

    // secure check - correct FTAN?
    if (!\bin\SecureTokens::checkFTAN ()) {
        $aMessage = \sprintf("%s\n","ModifySettings - Missing FTAN ".$oTrans->MESSAGE_GENERIC_SECURITY_ACCESS);
        $admin->print_error($aMessage, $sAddonBackUrl );
    }

    $iSettingId = $admin->checkIDKEY('SettingsID', false,'POST');
    if($iSettingId === false ) {
        $aMessage = \sprintf("%s\n","ModifySettings - Missing IDKey ".$oTrans->MESSAGE_GENERIC_SECURITY_ACCESS);
        $admin->print_error($aMessage, $sAddonBackUrl );
    }

        $aFtan = SecureTokens::getFTAN();

        // complete array with replacements
        $aTplDefaults = array(
            'WB_URL' => WB_URL,
            'WB_PATH' => WB_PATH,
            'MODULE_THEME_URL'     => $sAddonThemeUrl,
            'MODULE_THEME_PATH'    => $sAddonThemePath,
            'ICON_URL'             => $sAddonThemeUrl.'/images',
            'ADDON_NAME'           => strtolower($sAddonName),
            'ADDONNAME'            => strtoupper($sAddonName),
            'ADDONURL'             => $sAddonUrl,
            'LANGUAGE'             => LANGUAGE,
            'PAGE_ID'              => $page_id,
            'SECTION_ID'           => $section_id,
            'FTAN_NAME'            => $aFtan['name'],
            'FTAN_VALUE'           => $aFtan['value'],
            'LANGUAGE'             => LANGUAGE,
            'ICON_URL'             => $sAddonThemeUrl.'/images',
            'THEME_URL'            => $sAddonThemeUrl,
            'MODIFY_URL'           => ADMIN_URL.'/pages/modify.php?page_id='.(int)$page_id,
            'SAVE_URL'             => ADMIN_URL.'/pages/save.php',
            'CANCEL_URL'           => ADMIN_URL.'/pages/modify.php?page_id='.(int)$page_id,
            'SETTINGSID'           => $admin->getIDKEY('Settings'),
        );

        $aTwigdata = $aTplDefaults;

    $oBEFunctions = new Faqbaker();
    //settings
    $aTwigdata['setting']                           = $oBEFunctions->getFaqbakerSettings($section_id);
    $aTwigdata['CountTemplates']                    = $oBEFunctions->getFAQTemplateEntrys($section_id);
    $aTwigdata['TemplateList']                      = $oBEFunctions->getFAQAllTemplatesArray($section_id);
    $aTwigdata['lang']                              = $oTrans->getLangArray();
    
//    echo "<pre>";
//    print_r($aTwigdata['TemplateList']);
//    echo "</pre>";

        if (is_readable($sAddonThemePath.'/ModifySettings.twig'))
            {
                $loader = new \Twig\Loader\FilesystemLoader($sAddonThemePath);
                $oTwig  = new \Twig\Environment($loader, [
                    'autoescape'       => false,
                    'cache'            => false,
                    'strict_variables' => false,
                    'debug'            => false,
                    'auto_reload'      => true,
                ]);

            
            $oTwig->addFilter(new TwigFilter('strftime', 'strftime_filter'));
            $oTwig->addFilter(new TwigFilter('var_dump','var_dump'));
            echo $oTwig->render('ModifySettings.twig', $aTwigdata);
        }
    
}else{
    echo $oTrans['FQTEXT_INACTIVE_SECTION']."<br>";

}
