<?php
/**
 * @category     Addons
 * @package      page module: faqbaker
 * @copyright    Uwe Jacobsen <webdesign@jacobi22.com>
 * @author       Uwe Jacobsen <webdesign@jacobi22.com>
 * @license      http://www.gnu.org/licenses/gpl.html   GPL License
 * @version      2.2.0
 * @lastmodified $Date: 2023/03/09
 * @since        File available since 2023/03/09
 * @description  addon faqbaker
 *
 * cmdMoveItem.inc
/* -------------------------------------------------------- */
//            echo "<pre>POST in MoveItem.inc.php:<br>";
//            print_r($_POST);
//            echo "</pre>";
//            echo "<pre>GET in MoveItem.inc.php:<br>";
//            print_r($_GET);
//            echo "</pre>";
           
/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 Not Found'; \flush(); exit;}
/* -------------------------------------------------------- */

use addon\faqbaker\Lib\Faqbaker;
use bin\{WbAdaptor, SecureTokens};
use bin\helpers\{PreCheck};


//load some initial datas
if (is_readable($sAddonPath.'/init.php'))     {require ($sAddonPath.'/init.php');}

$oTrans->enableAddon('modules\\'.$sAddonName);

// back to the module overview
$sec_anchor = '#'.(\defined('SEC_ANCHOR') && !empty(SEC_ANCHOR) ? SEC_ANCHOR : 'Sec' ).(int)$section_id;
$sAddonBackUrl = ADMIN_URL.'/pages/modify.php?page_id='.(int)$page_id.$sec_anchor;

if (isset($_GET['cat_id'])){
    $sCommonFieldID = $admin->checkIDKEY('cat_id', false, 'GET');
        if(!$sCommonFieldID) {
            $admin->print_header();
            $admin->print_error($MESSAGE['GENERIC_SECURITY_ACCESS'], $sAddonBackUrl);
            exit();
        }
    $sCommonField = 'cat_id';
    $sCommonTable = TABLE_PREFIX.'mod_faq_categories';
}
elseif (isset($_GET['question_id'])){
    $sCommonFieldID = $admin->checkIDKEY('question_id', false, 'GET');
        if(!$sCommonFieldID) {
            $admin->print_header();
            $admin->print_error($oTrans->MESSAGE_GENERIC_SECURITY_ACCESS, $sAddonBackUrl);
            exit();
        }
    $sCommonField = 'question_id';
    $sCommonTable = TABLE_PREFIX.'mod_faq_questions';
}

else {}

// Include the ordering class
require(WB_PATH.'/framework/class.order.php');

$order = new order($sCommonTable, 'position', $sCommonField, 'section_id');
if(isset($_GET['dir']) && $_GET['dir']== "up") {
    if($order->move($sCommonFieldID,0)) {
//        $admin->print_header();
        $admin->print_success($oTrans->FQTEXT_ITEM_REORDERED, $sAddonBackUrl);
    } else {
//        $admin->print_header();
        $admin->print_error($oTrans->FQTEXT_ERROR_ITEM_REORDER, $sAddonBackUrl);
    }
}

if(isset($_GET['dir']) && $_GET['dir']== "down") {
    if($order->move($sCommonFieldID,1)) {
//        $admin->print_header();
        $admin->print_success($oTrans->FQTEXT_ITEM_REORDERED, $sAddonBackUrl);
    } else {
//        $admin->print_header();
        $admin->print_error($oTrans->FQTEXT_ERROR_ITEM_REORDER, $sAddonBackUrl);
    }
}
//$order->clean( $section_id );

// end of file

