<?php
/**
* @category     Addons
 * @package      page module: faqbaker
 * @copyright    Uwe Jacobsen <webdesign@jacobi22.com>
 * @author       Uwe Jacobsen <webdesign@jacobi22.com>
 * @license      http://www.gnu.org/licenses/gpl.html   GPL License
 * @version      2.2.0
 * @lastmodified $Date: 2023/03/09
 * @since        File available since 2023/03/09
 * @description  addon faqbaker
 *
 * Savecat.inc.php
 */

use addon\faqbaker\Lib\Faqbaker;
use bin\{WbAdaptor, SecureTokens};
use bin\helpers\{PreCheck};



/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
if(defined('WB_PATH') == false) { die('Illegale file access /'.basename(__DIR__).'/'.basename(__FILE__).''); }
/* -------------------------------------------------------- */
//    echo "<pre>";
//    print_r($_POST);
//    echo "</pre>";
    
//load some initial datas
   if (is_readable($sAddonPath.'/init.php'))     {require ($sAddonPath.'/init.php');}
    $oTrans->enableAddon('modules\\'.$sAddonName);
    
// back to the module overview
$sec_anchor = '#'.(\defined('SEC_ANCHOR') && !empty(SEC_ANCHOR) ? SEC_ANCHOR : 'Sec' ).(int)$section_id;
$sAddonBackUrl = ADMIN_URL.'/pages/modify.php?page_id='.(int)$page_id.$sec_anchor;
    
    if (!function_exists('xnl2br')){require(WB_PATH.'/framework/functions.php');}

try {    
        // secure check - correct FTAN?
    if (!\bin\SecureTokens::checkFTAN ()) {
        $aMessage = \sprintf("%s\n","Missing FTAN ".$oTrans->MESSAGE_GENERIC_SECURITY_ACCESS);
        $admin->print_error($aMessage, $sAddonBackUrl );
    }   
    if(isset($aRequestVars['cmd']) && ($aRequestVars['cmd'] == 'saveCat')) { 
        // marker_id / default='0'
        if(isset($aRequestVars['cat_id'])) {
                    $iCatID = $admin->checkIDKEY('cat_id', false, 'POST');
            } else {
                    $iCatID = 999999;
            }
        // catname / default=''
        if(isset($aRequestVars['cat_name']) && ($aRequestVars['cat_name'] != '')) {
                $sCatName = $admin->StripCodeFromText($aRequestVars['cat_name']);
        }else{
            throw new \Exception ($oTrans->FQTEXT_NO_CAT_TITLE_ERROR);
        }
        // cat description
        if(isset($aRequestVars['cat_desc'])) {
            $sCatDesc = $aRequestVars['cat_desc'];
            if(ini_get('magic_quotes_gpc')==true)
            {
                $sCatDesc = $admin->strip_slashes($aRequestVars['cat_desc']);
            }
        $sCatDesc = $admin->ReplaceAbsoluteMediaUrl($sCatDesc);
        }else{
            $sCatDesc = '';
        }
        // active        
        if (isset($aRequestVars['active']) && is_numeric($aRequestVars['active']) ) {
            $active = intval($aRequestVars['active']);
        } else {
            $active= 0;
        }
        
        // position        
        if (isset($aRequestVars['position']) && is_numeric($aRequestVars['position']) ) {
            $position = intval($aRequestVars['position']);
        } else {
            $position= 0;
        }
        $sqlSet =  '`'.TABLE_PREFIX.'mod_faq_categories` SET '
                .  '`section_id`      = '.(int)$section_id.', '
                .  '`page_id`         = '.(int)$page_id.', '
                .  '`cat_name`        = \''.$database->escapeString($sCatName).'\', '
                .  '`cat_desc`        = \''.$database->escapeString($sCatDesc).'\', '
                .  '`position`        = '.(int)$position.', '
                .  '`active`          = '.(int)$active.' ';

        // search for instance of this module in section
        $sql = 'SELECT COUNT(*) FROM `'.TABLE_PREFIX.'mod_faq_categories` '
             . 'WHERE `section_id` = '.$section_id.' '
             . 'AND `cat_id` = '.$iCatID;
//        echo $sql;
        if ($database->get_one($sql)) {
            // if matching record already exists run UPDATE
            $sql = 'UPDATE '.$sqlSet.' '
                  .'WHERE `section_id`='.$section_id.' '
                  .'AND `cat_id`= '.$iCatID;
            $action = 'upgrade';
//          echo 'UPDATE: <br>'.$sql;
        } else {
            // if no matching record exists INSERT new record// Insert row
            $sql = 'INSERT INTO '.$sqlSet;
            $action = 'insert';
//          echo 'INSERT: <br>'.$sql;
        }

        if (!$database->query($sql)){
            throw new \Exception ($database->get_error());
        }
        if($action == 'insert'){
            $oSortCats   = new order(TABLE_PREFIX.'mod_faq_categories', 'position', 'cat_id', 'section_id');
            #$oSortCats->clean( $section_id );
        }
        if ($position == 0){
            $oSortCats   = new order(TABLE_PREFIX.'mod_faq_categories', 'position', 'cat_id', 'section_id');
            $oSortCats->clean( $section_id );
        }
        
    }
}catch (\Exception $ex) {
    $sErrMsg = xnl2br(sprintf('[%d] %s', $ex->getLine(), wordwrap($ex->getMessage(), 75, "\n", false)));
    $admin->print_error ($sErrMsg, $sAddonBackUrl);
    exit;
}
// end of file


