<?php
/**
 * @category     Addons
 * @package      page module: faqbaker
 * @copyright    Uwe Jacobsen <webdesign@jacobi22.com>
 * @author       Uwe Jacobsen <webdesign@jacobi22.com>
 * @license      http://www.gnu.org/licenses/gpl.html   GPL License
 * @version      2.2.0
 * @lastmodified $Date: 2023/03/09
 * @since        File available since 2023/03/09
 * @description  addon faqbaker
 *
 * Savepresets.inc.php
 * 
 */
use addon\faqbaker\Lib\Faqbaker;
use bin\{WbAdaptor, SecureTokens};
use bin\helpers\{PreCheck};


/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
if(defined('WB_PATH') == false) { die('Illegale file access /'.basename(__DIR__).'/'.basename(__FILE__).''); }
/* -------------------------------------------------------- */
//        echo "<pre>";
//        print_r($_POST);
//        echo "</pre>";

    if (is_readable($sAddonPath.'/init.php'))     {require ($sAddonPath.'/init.php');}
    
// back to the module overview
$sec_anchor = '#'.(\defined('SEC_ANCHOR') && !empty(SEC_ANCHOR) ? SEC_ANCHOR : 'Sec' ).(int)$section_id;
$sAddonBackUrl = ADMIN_URL.'/pages/modify.php?page_id='.(int)$page_id.$sec_anchor;
    
if (!function_exists('xnl2br')){require(WB_PATH.'/framework/functions.php');}

try {
    if (!\bin\SecureTokens::checkFTAN()) {
        throw new \Exception($oTrans->MESSAGE_GENERIC_SECURITY_ACCESS);
    }

    if (isset($aRequestVars['cmd']) && ($aRequestVars['cmd'] == 'savePresets')) {

        if ($aRequestVars['use_template'] && ($aRequestVars['use_template'] > 0)) {
            foreach ($aRequestVars["use_template"] as $key => $value) {

                $sTemplateName = $aRequestVars['template_title'][$key];
                $sTemplateDesc = $aRequestVars['template_desc'][$key];
                $sTemplateFile = $aRequestVars['template_filename'][$key];
                include($sTemplateFile);
                $position= 0;
                $active = 1;
                
                $sqlSet = '`' . TABLE_PREFIX . 'mod_faq_templates` SET '
                        . '`section_id`      = ' . (int) $section_id . ', '
                        . '`template_name`   = \'' . $database->escapeString($sTemplateName) . '\', '
                        . '`template_desc`   = \'' . $database->escapeString($sTemplateDesc) . '\', '
                        . '`template_code`   = \'' . $database->escapeString($sTemplateCode) . '\', '
                        . '`position`        = ' . (int) $position . ', '
                        . '`active`          = ' . (int) $active . ' ';

                // if no matching record exists INSERT new record// Insert row
                $sql = 'INSERT INTO ' . $sqlSet;
                $action = 'insert';
//                echo 'INSERT: <br>' . $sql;
                if (!$database->query($sql)) {
                    throw new \Exception($database->get_error());
                }
            }

                
        }
    }
} catch (\Exception $ex) {
//    $sErrMsg = xnl2br(sprintf('[%d] %s', $ex->getLine(), $ex->getMessage()));
//    $admin->print_error ($sErrMsg, $sAddonBackUrl);
    $sErrMsg = xnl2br(sprintf('[%d] %s', $ex->getLine(), wordwrap($ex->getMessage(), 75, "\n", false)));
    $admin->print_error($sErrMsg, $sAddonBackUrl);
    exit;
}    

// end of file


