<?php
/**
* @category     Addons
 * @package      page module: faqbaker
 * @copyright    Uwe Jacobsen <webdesign@jacobi22.com>
 * @author       Uwe Jacobsen <webdesign@jacobi22.com>
 * @license      http://www.gnu.org/licenses/gpl.html   GPL License
 * @version      2.2.0
 * @lastmodified $Date: 2023/03/09
 * @since        File available since 2023/03/09
 * @description  addon faqbaker
 *
 * Savequestion.inc.php 
 */
use addon\faqbaker\Lib\Faqbaker;
use bin\{WbAdaptor, SecureTokens};
use bin\helpers\{PreCheck};

/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 Not Found'; \flush(); exit;}
/* -------------------------------------------------------- */
//        echo "<pre>";
//        print_r($_POST);
//        echo "</pre>";
//load some initial datas
    if (is_readable($sAddonPath.'/init.php'))     {require ($sAddonPath.'/init.php');}
    
    $oTrans->enableAddon('modules\\'.$sAddonName);

// back to the module overview
$sec_anchor = '#'.(\defined('SEC_ANCHOR') && !empty(SEC_ANCHOR) ? SEC_ANCHOR : 'Sec' ).(int)$section_id;
$sAddonBackUrl = ADMIN_URL.'/pages/modify.php?page_id='.(int)$page_id.$sec_anchor;
    
    if (!function_exists('xnl2br')){require(WB_PATH.'/framework/functions.php');}
    

try {    
    if (!\bin\SecureTokens::checkFTAN ()) {
        throw new \Exception ($oTrans->MESSAGE_GENERIC_SECURITY_ACCESS);
    }
    
    if(isset($aRequestVars['cmd']) && ($aRequestVars['cmd'] == 'savequestion')) { 
        // actual question_id / '0' for an new record
        if(isset($aRequestVars['question_id']) && (!is_numeric($aRequestVars['question_id'])) ) {
                $iQuestionID = $admin->checkIDKEY('question_id', false,'POST');
            } else {
                $iQuestionID = 999999;
            }
        // question / default=''
        if(isset($aRequestVars['question']) && ($aRequestVars['question'] != '')) {
            $sQuestionText = $admin->StripCodeFromText($aRequestVars['question']);
        }else{
            throw new \Exception ($oTrans->FQTEXT_NO_QUEST_TITLE_ERROR);
        }
        // keywords / default=''
        if(isset($aRequestVars['keywords'])) {
            $sKeywords = $admin->StripCodeFromText($admin->get_post('keywords'));
        }else{
            $sKeywords = '';
        }
        // website_answer
        if(isset($aRequestVars['answer'])) {
            $sAnswerText = $aRequestVars['answer'];
            if(ini_get('magic_quotes_gpc')==true)
            {
                $sAnswerText = $admin->strip_slashes($aRequestVars['answer']);
            }
        $sAnswerText = $admin->ReplaceAbsoluteMediaUrl($sAnswerText);
        }
        // catgroup
        if (isset($aRequestVars['catgroup']) && is_numeric($aRequestVars['catgroup']) ) {
            $iCatGroup = intval($aRequestVars['catgroup']);
        } else {
            $iCatGroup = 1;
        }
        // active        
        if (isset($aRequestVars['active']) && is_numeric($aRequestVars['active']) ) {
            $active = intval($aRequestVars['active']);
        } else {
            $active = 0;
        }
        // position        
        if (isset($aRequestVars['position']) && is_numeric($aRequestVars['position']) ) {
            $position = intval($aRequestVars['position']);
        } else {
            $position= 0;
        }
        $iActualTime = time()+ TIMEZONE;
        $sCreatedWhen = ((isset($aRequestVars['created_when']) && $aRequestVars['created_when'] != 0) ? ($aRequestVars['created_when']) : $iActualTime);
        $sCreatedBy = ((isset($aRequestVars['created_by']) && $aRequestVars['created_by'] != 0) ? ($aRequestVars['created_by']) : $admin->getUserId());
        $sModifiedWhen = $iActualTime;
        $sModifiedBy = $admin->getUserId();

        if(isset($aRequestVars['publ_date_start'])) {
            if(trim($aRequestVars['publ_date_start']) == '0' || trim($aRequestVars['publ_date_start']) == '') {
                
                $sPublishedStart = $iActualTime;
            } else {
//                $sPublishedStart = strtotime($aRequestVars['publ_date_start'])+ TIMEZONE;
                $sPublishedStart = strtotime($aRequestVars['publ_date_start']);
            }
        if(trim($aRequestVars['publ_date_end']) == '0' || trim($aRequestVars['publ_date_end']) == '') {
                $sPublishedEnd = 0;
            } else {
//                $sPublishedEnd = strtotime($aRequestVars['item_date_end'])+ TIMEZONE;
                $sPublishedEnd = strtotime($aRequestVars['publ_date_end']);
            }
        }
        
        
        $sqlSet =  '`'.TABLE_PREFIX.'mod_faq_questions` SET '
                .  '`section_id`      = '.(int)$section_id.', '
                .  '`page_id`         = '.(int)$page_id.', '
                .  '`cat_id`          = '.(int)$iCatGroup.', '
                .  '`position`        = '.(int)$position.', '
                .  '`active`          = '.(int)$active.', ' 
                .  '`question`        = \''.$database->escapeString($sQuestionText).'\', '
                .  '`answer`          = \''.$database->escapeString($sAnswerText).'\', '
                .  '`keywords`        = \''.$database->escapeString($sKeywords).'\', '
                .  '`created_when`    = '.(int)$sCreatedWhen.', '
                .  '`created_by`      = '.(int)$sCreatedBy.', '
                .  '`modified_when`   = '.(int)$sModifiedWhen.', '
                .  '`modified_by`     = '.(int)$sModifiedBy.', '
                .  '`published_when`  = \''.$database->escapeString($sPublishedStart).'\', '
                .  '`published_until` = \''.$database->escapeString($sPublishedEnd).'\' '
                .  '';

        // search for instance of this module in section
        $sql = 'SELECT COUNT(*) FROM `'.TABLE_PREFIX.'mod_faq_questions` '
             . 'WHERE `section_id` = '.$section_id.' '
             . 'AND `question_id` = '.$iQuestionID;
        if ($database->get_one($sql)) {
            // if matching record already exists run UPDATE
            $sql = 'UPDATE '.$sqlSet.' '
                  .'WHERE `section_id`='.$section_id.' '
                  .'AND `question_id`= '.$iQuestionID;
            $action = 'upgrade';
//            echo 'UPDATE: <br>'.$sql;
        } else {
            // if no matching record exists INSERT new record// Insert row
            $sql = 'INSERT INTO '.$sqlSet;
            $action = 'insert';
//            echo 'INSERT: <br>'.$sql;
        }

        if (!$database->query($sql)){
            throw new \Exception ($database->get_error());
        }
        if($action == 'insert'){
            $oSortQuests   = new order(TABLE_PREFIX.'mod_faq_questions', 'position', 'question_id', 'section_id');
            #$sQuestionID->clean( $section_id );
        }
        if ($position == 0){
            $oSortQuests   = new order(TABLE_PREFIX.'mod_faq_questions', 'position', 'question_id', 'section_id');
            $oSortQuests->clean( $section_id );
        }
    }
}catch (\Exception $ex) {
    $sErrMsg = xnl2br(sprintf('[%d] %s', $ex->getLine(), wordwrap($ex->getMessage(), 75, "\n", false)));
    $admin->print_error ($sErrMsg, $sAddonBackUrl);
    exit;
}
// end of file


