<?php
/**
* @category     Addons
 * @package      page module: faqbaker
 * @copyright    Uwe Jacobsen <webdesign@jacobi22.com>
 * @author       Uwe Jacobsen <webdesign@jacobi22.com>
 * @license      http://www.gnu.org/licenses/gpl.html   GPL License
 * @version      2.2.0
 * @lastmodified $Date: 2023/03/09
 * @since        File available since 2023/03/09
 * @description  addon faqbaker
 *
 * SaveSettings.inc.php
 */

use addon\faqbaker\Lib\Faqbaker;
use bin\{WbAdaptor, SecureTokens};
use bin\helpers\{PreCheck};


/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
if(defined('WB_PATH') == false) { die('Illegale file access /'.basename(__DIR__).'/'.basename(__FILE__).''); }
/* -------------------------------------------------------- */
//        echo "<pre>";
//        print_r($_POST);
//        echo "</pre>";

if (is_readable($sAddonPath.'/init.php'))     {require ($sAddonPath.'/init.php');}
      // back to the module overview
$sec_anchor = '#'.(\defined('SEC_ANCHOR') && !empty(SEC_ANCHOR) ? SEC_ANCHOR : 'Sec' ).(int)$section_id;
$sAddonBackUrl = ADMIN_URL.'/pages/modify.php?page_id='.(int)$page_id.$sec_anchor;

    //  FTAN-CHECK
    $sSettingsID = $admin->checkIDKEY('SettingsID', false, 'POST');
        // Get id
    if(!$sSettingsID) {
        $admin->print_error('SaveSettings.php '.$oTrans->MESSAGE_GENERIC_SECURITY_ACCESS, $sAddonBackUrl);
                exit();
    }
    $newSettings = array();
    $aErrorMsg = array();
    //Daten aus $aRequestVars auswerten und validieren
    $newSettings['section_id'] = $section_id;
    $newSettings['page_id'] = $page_id;
    
    if(isset($aRequestVars['cmd']) && ($aRequestVars['cmd'] == 'savesetting')) {
        // use_glossar
        if (isset($aRequestVars['use_glossar']) && is_numeric($aRequestVars['use_glossar']) ) {
            $newSettings['use_glossar'] = intval($aRequestVars['use_glossar']);
        } else {
            $newSettings['use_glossar'] = '0';
        }        
    // header / default=''
        if(isset($aRequestVars['header'])) {
            $newSettings['header'] = $admin->StripCodeFromText($admin->get_post('header'));
        }else{
            $newSettings['header'] = '';
        }
        // show_header  default=0
        if (isset($aRequestVars['show_header']) && is_numeric($aRequestVars['show_header']) ) {
            $newSettings['show_header'] =  intval($aRequestVars['show_header']);
        } else {
            $newSettings['show_header'] = 0;
        }
        // headerdesc / default=''
        if(isset($aRequestVars['headerdesc'])) {
            $newSettings['headerdesc'] = $admin->StripCodeFromText($admin->get_post('headerdesc'));
        }else{
            $newSettings['headerdesc'] = '';
        }
        // show_headerdesc  default=0
        if (isset($aRequestVars['show_headerdesc']) && is_numeric($aRequestVars['show_headerdesc']) ) {
            $newSettings['show_headerdesc'] =  intval($aRequestVars['show_headerdesc']);
        } else {
            $newSettings['show_headerdesc'] = 0;
        }
        // footer / default=''
        if(isset($aRequestVars['footer'])) {
            $newSettings['footer'] = $admin->StripCodeFromText($admin->get_post('footer'));
        }else{
            $newSettings['footer'] = '';
        }
        // show_header  default=0
        if (isset($aRequestVars['show_footer']) && is_numeric($aRequestVars['show_footer']) ) {
            $newSettings['show_footer'] =  intval($aRequestVars['show_footer']);
        } else {
            $newSettings['show_footer'] = 0;
        }
        // output_template  default = 1
        if (isset($aRequestVars['output_template']) && is_numeric($aRequestVars['output_template']) ) {
            $newSettings['output_template'] = intval($aRequestVars['output_template']);
        } else {
            $newSettings['output_template'] = 1;
        }
        // sort_cat_name - default = 0
        if (isset($aRequestVars['sort_cat_name']) && is_numeric($aRequestVars['sort_cat_name']) ) {
            $newSettings['sort_cat_name'] = intval($aRequestVars['sort_cat_name']);
        } else {
            $newSettings['sort_cat_name'] = '1';
        }
        // sort_quest_in_cats  - default = 0
        if (isset($aRequestVars['sort_quest_in_cats']) && is_numeric($aRequestVars['sort_quest_in_cats']) ) {
            $newSettings['sort_quest_in_cats'] = intval($aRequestVars['sort_quest_in_cats']);
        } else {
            $newSettings['sort_quest_in_cats'] = '1';
        }
        // use_keywords  - default = 1
        if (isset($aRequestVars['use_keywords']) && is_numeric($aRequestVars['use_keywords']) ) {
            $newSettings['use_keywords'] = intval($aRequestVars['use_keywords']);
        } else {
            $newSettings['use_keywords'] = '1';
        }
                
        // use_templates - default = view_original.twig
        if (isset($aRequestVars['use_templates']) && is_numeric($aRequestVars['use_templates']) ) {
            $newSettings['use_templates'] =  intval($aRequestVars['use_templates']);
        } else {
            $newSettings['use_templates'] = 0;
        }
                
        // use_wysiwyg - default = view_original.twig
        if (isset($aRequestVars['use_wysiwyg']) && is_numeric($aRequestVars['use_wysiwyg']) ) {
            $newSettings['use_wysiwyg'] =  intval($aRequestVars['use_wysiwyg']);
        } else {
            $newSettings['use_wysiwyg'] = 1;
        }
        //SQL wich is used for all updates
        $rawUpdtSQL = "UPDATE `".TABLE_PREFIX."mod_faq_settings` SET `s_value` = '%s' WHERE "
            ."`section_id` = '".$section_id."' AND `s_name` = '%s';";
        // execute SQL
        $sUpdateSql =array();
        foreach ($newSettings as $s_name=>$s_value){
            if (!is_array($s_value)) {
                $sSql = sprintf($rawUpdtSQL, $database->escapeString($s_value), $s_name);
            } else {
                $sSql = sprintf($rawUpdtSQL, serialize($s_value), $s_name);
            }
            $sUpdateSql[] = $sSql;
//            echo $sSql."<br>";
            if (!$database->query($sSql)){
                throw new \Exception ($database->get_error());
            }
        }

        if (sizeof($aErrorMsg)){
          $admin->print_error(implode('<br>', $aErrorMsg), $sAddonBackUrl);
        }
    }
//end of file

