<?php
/**
 * @category     Addons
 * @package      page module: faqbaker
 * @copyright    Uwe Jacobsen <webdesign@jacobi22.com>
 * @author       Uwe Jacobsen <webdesign@jacobi22.com>
 * @license      http://www.gnu.org/licenses/gpl.html   GPL License
 * @version      2.2.0
 * @lastmodified $Date: 2023/03/09
 * @since        File available since 2023/03/09
 * @description  addon faqbaker
 *
 * cmdSaveTemplate.inc
 * 
 */
use addon\faqbaker\Lib\Faqbaker;
use bin\{WbAdaptor, SecureTokens};
use bin\helpers\{PreCheck};


/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
if(defined('WB_PATH') == false) { die('Illegale file access /'.basename(__DIR__).'/'.basename(__FILE__).''); }
/* -------------------------------------------------------- */
//        echo "<pre>";
//        print_r($_POST);
//        echo "</pre>";

if (is_readable($sAddonPath.'/init.php'))     {require ($sAddonPath.'/init.php');}
    
    // back to the module overview
$sec_anchor = '#'.(\defined('SEC_ANCHOR') && !empty(SEC_ANCHOR) ? SEC_ANCHOR : 'Sec' ).(int)$section_id;
$sAddonBackUrl = ADMIN_URL.'/pages/modify.php?page_id='.(int)$page_id.$sec_anchor;
    
    if (!function_exists('xnl2br')){require(WB_PATH.'/framework/functions.php');}
//echo "<pre>";
//print_r($_POST);
//echo "</pre>";
try {    
    if (!\bin\SecureTokens::checkFTAN ()) {
        throw new \Exception ($oTrans->MESSAGE_GENERIC_SECURITY_ACCESS);
    } 
    
    if(isset($aRequestVars['cmd']) && ($aRequestVars['cmd'] == 'saveTemplate')) { 
        
        // marker_id / default='0'
        if(isset($aRequestVars['template_id']) && (!is_numeric($aRequestVars['template_id'])) ) {
                    $iTemplateID = $admin->checkIDKEY('template_id', false, 'POST');
                    
            } else {
                    $iTemplateID = 999999;
            }
        // TemplateName / default=''
        if(isset($aRequestVars['template_name']) && ($aRequestVars['template_name'] != '')) {
            $sTemplateName = $admin->StripCodeFromText($aRequestVars['template_name']);
        }else{
            throw new \Exception ($oTrans->FBTEXT_NO_TEMPL_TITLE_ERROR);
        }       
        // link_name / default=''
        if(isset($aRequestVars['template_desc'])) {
            $sTemplateDesc = $admin->StripCodeFromText($aRequestVars['template_desc']);
        }else{
            $sTemplateDesc = '';
        }
        // template_code / default=''
        if(isset($aRequestVars['template_code'])) {
            $sTemplateCode = $admin->get_post('template_code');
        }else{
            $sTemplateCode = '';
        }
        
        // active        
        if (isset($aRequestVars['active']) && is_numeric($aRequestVars['active']) ) {
            $active = intval($aRequestVars['active']);
        } else {
            $active = 0;
        }
        // position        
        if (isset($aRequestVars['position']) && is_numeric($aRequestVars['position']) ) {
            $position = intval($aRequestVars['position']);
        } else {
            $position= 0;
        }
        $sqlSet =  '`'.TABLE_PREFIX.'mod_faq_templates` SET '
                .  '`section_id`      = '.(int)$section_id.', '
                .  '`template_name`   = \''.$database->escapeString($sTemplateName).'\', '
                .  '`template_desc`   = \''.$database->escapeString($sTemplateDesc).'\', '
                .  '`template_code`   = \''.$database->escapeString($sTemplateCode).'\', '
                .  '`position`        = '.(int)$position.', '
                .  '`active`          = '.(int)$active.' ';

        if($iTemplateID != 999999){
            // if matching record already exists run UPDATE
            $sql = 'UPDATE '.$sqlSet.' '
                  .'WHERE `section_id`='.$section_id.' '
                  .'AND `template_id`= '.$iTemplateID;
            $action = 'upgrade';
//            echo 'UPDATE: <br>'.$sql;
        } else {
            // if no matching record exists INSERT new record// Insert row
            $sql = 'INSERT INTO '.$sqlSet;
            $action = 'insert';
//            echo 'INSERT: <br>'.$sql;
        }

        if (!$database->query($sql)){
            throw new \Exception ($database->get_error());
        }
        if($action == 'insert'){
            $oSortTemplates   = new order(TABLE_PREFIX.'mod_faq_templates', 'position', 'group_id', 'section_id');
            #$oSortTemplates->clean( $section_id );
        }
        if ($position == 0){
            $oSortTemplates   = new order(TABLE_PREFIX.'mod_faq_templates', 'position', 'group_id', 'section_id');
            $oSortTemplates->clean( $section_id );
        }
    }
}catch (\Exception $ex) {
//    $sErrMsg = xnl2br(sprintf('[%d] %s', $ex->getLine(), $ex->getMessage()));
//    $admin->print_error ($sErrMsg, $sAddonBackUrl);
    $sErrMsg = xnl2br(sprintf('[%d] %s', $ex->getLine(), wordwrap($ex->getMessage(), 75, "\n", false)));
    $admin->print_error ($sErrMsg, $sAddonBackUrl);
    exit;
}    

// end of file


