<?php
/**
 * @category     Addons
 * @package      page module: faqbaker
 * @copyright    Uwe Jacobsen <webdesign@jacobi22.com>
 * @author       Uwe Jacobsen <webdesign@jacobi22.com>
 * @license      http://www.gnu.org/licenses/gpl.html   GPL License
 * @version      2.2.0
 * @lastmodified $Date: 2023/03/09
 * @since        File available since 2023/03/09
 * @description  addon faqbaker
 *
 * View.inc.php
 * 
 */

//            echo "<pre>";
//            print_r($_POST);
//            echo "</pre>";

use addon\faqbaker\Lib\Faqbaker;
use bin\{WbAdaptor, SecureTokens};
use bin\helpers\{PreCheck};

use Twig\Loader\FilesystemLoader;
use Twig\Environment;
use Twig\TwigFilter;

/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 Not Found'; \flush(); exit;}
/* -------------------------------------------------------- */


if (is_readable($sAddonPath.'/init.php'))     {require ($sAddonPath.'/init.php');}

    $oTrans->enableAddon('modules\\'.$sAddonName);

    $aTplDefaults = array(
            'WB_URL' => WB_URL,
            'PAGE_ID'              => PAGE_ID,
            'SECTION_ID'           => $section_id,
            'LANGUAGE'             => LANGUAGE,
            'ICON_URL'             => $sAddonTemplateUrl.'/images',
            'TEMPLATE_URL'         => $sAddonTemplateUrl,
            'ADDON_URL'            => $sAddonUrl,
            'ADDON_NAME'           => $sAddonName,
        );
    
    $aTwigdata1 = $aTplDefaults;
    $oBEFunctions = new Faqbaker();

    // all items for this section
    $iCatOrder                                  = $oBEFunctions->FAQCatSortMode($section_id);
    $sQuestSortMode                             = $oBEFunctions->FAQQuestSortMode($section_id);
    $aTwigdata['setting']                       = $oBEFunctions->getFaqbakerSettings($section_id);
    $iFeTemplateID                              = $oBEFunctions->getFAQFeTemplateID($section_id);
    $iFeTemplateType                            = $oBEFunctions->getModuleType($section_id);
    $aTwigdata['TEMPLATE']                      = $oBEFunctions->getFAQFrontendTemplate($section_id, $iFeTemplateID);
    $aTwigdata['items']                         = $oBEFunctions->getFAQItemsViewArray($section_id, $iCatOrder, $sQuestSortMode);
    $aTwigdata['CatList']                       = $oBEFunctions->getFAQAllCatsArray($section_id);
    $aTwigdata['CatTitles']                     = $oBEFunctions->getFAQAllCatTitles($section_id);
    $aTwigdata['lang']                              = $oTrans->getLangArray();
    $sTemplateName = (($iFeTemplateType ?? '1') == '1'  ? 'glossary' : 'faq');
//    echo "<pre>FE-Template-ID: ";
//    print_r($aTwigdata['TEMPLATE']);
//    echo "</pre>";  

    
    if (is_readable($sAddonTemplatePath.'/view_'.$sTemplateName.'.twig'))
        {
            // create twig template object
            $loader = new \Twig\Loader\FilesystemLoader($sAddonTemplatePath);
            $oTwig  = new \Twig\Environment($loader, [
                    'autoescape'       => false,
                    'cache'            => false,
                    'strict_variables' => false,
                    'debug'            => false,
                    'auto_reload'      => true,
                ]);
        }

    $oTwig->addFilter(new TwigFilter('var_dump','var_dump'));
    if ($iFeTemplateID != 0 && $aTwigdata['TEMPLATE'] != ''){
            $oTpl = $oTwig->createTemplate($aTwigdata['TEMPLATE']);
            $oTpl->display($aTwigdata);
    }else{
        echo $oTwig->render('view_'.$sTemplateName.'.twig', $aTwigdata);               
    }
// end of file
    

