<?php
/**
 * @category     Addons
 * @package      page module: faqbaker
 * @copyright    Uwe Jacobsen <webdesign@jacobi22.com>
 * @author       Uwe Jacobsen <webdesign@jacobi22.com>
 * @license      http://www.gnu.org/licenses/gpl.html   GPL License
 * @version      2.2.0
 * @lastmodified $Date: 2023/03/09
 * @since        File available since 2023/03/09
 * @description  addon faqbaker
 *
*/


use addon\faqbaker\Lib\Faqbaker;
use bin\{WbAdaptor,SecureTokens,Sanitize};
use bin\helpers\{PreCheck,msgQueue,ParentList};
use src\Security\{CsfrTokens,Randomizer};
use src\Interfaces\Requester;
use bin\Requester\HttpRequester;
/* -------------------------------------------------------- */
// folderstructure steps to modules path
$sAppPath = dirname(dirname(__DIR__));
// load config created for modify or save module files if WB_PATH don't exist, '
if ( !defined( 'WB_PATH' ) ){require($sAppPath.'/config.php');}
// Must include code to prevent this file from being accessed directly
if (defined('WB_PATH') == false) { die('Cannot access '.basename(__DIR__).'/'.basename(__FILE__).' directly'); }
/* -------------------------------------------------------- */

$sCallingScript = $oReg->Request->getServerVar('SCRIPT_NAME');
$globalStarted = \preg_match('/upgrade\-script\.php$/', $sCallingScript);
$sWbVersion = ($globalStarted && \defined('VERSION') ? VERSION : WB_VERSION);
$oReg = (is_object($oReg) ? $oReg : WbAdaptor::getInstance());
$oApp = $oReg->getApplication();
    // needed for simple Dispatcher
    $sAddonName = basename($sAddonPath);
    $bIsBackend = ($oApp instanceof admin);

/*
    $AcpPath    = $sAppPath.'/'.ADMIN_DIRECTORY;
    $AppUrl     = WB_URL;
    $AcpUrl     = $AppUrl.'/'.ADMIN_DIRECTORY;
    $sAddonRel  = '/modules/'.$sAddonName;
    $sAddonUrl  = $AppUrl.$sAddonRel;
*/
    // An associative array that by default contains the contents of $_GET, $_POST and $_COOKIE.
    $aRequestVars = $_REQUEST;

    if (!function_exists('index_exists')){
    function index_exists($table_name, $index_name, $number_fields = 0)
    {
        global $database;
        $number_fields = intval($number_fields);
        $keys = 0;
        $sql = 'SHOW INDEX FROM `'.$table_name.'`';
        if (($res_keys = $database->query($sql))) {
            while (($rec_key = $res_keys->fetchRow(MYSQLI_ASSOC))) {
                if ( ($rec_key['Key_name'] || ($rec_key['Column_name']) == $index_name) ) {
                    $keys++;
                }
            }
        }
        if ( $number_fields == 0 ) {
            return ($keys != $number_fields);
        } else {
            return ($keys == $number_fields);
        }
    }
}

/* this function/closure is placed inside this file temporarely until a better place is found */
/*  function to update a var/value-pair(s) in table ****************************
 *  nonexisting keys are inserted
 *  @param string $table: name of table to use (without prefix)
 *  @param mixedthe firring with name of the key to update
 *  @param string $value: a sting with needed value, if $key is a string too
 *  @param array example the first entry is used as WHEE....... AND request
 *                  $aFieldsList = array(
 *                      'section_id' => $section_id,
 *                      'page_id' => $page_id,
 *                  );
 *
 *  @return bool:  true if any keys are updated, otherwise false
 */
if (!\function_exists('UpdateKeyValue')){
    function UpdateKeyValue($table, $key, $value = '', array $aExtraFields = [])
    {
        $oReg = WbAdaptor::getInstance();
        $oDb  = $oReg->getDatabase();
        if( !\is_array($key))
        {
            if (\trim($key) != '' )
            {
                $key = [ \trim($key) => \trim($value) ];
            } else {
                $key = [];
            }
        }
        $retval = [];
        $iFirst = 0;
        $aTmp  = [];
        $aIndexField  = [];
        $sExtraFields = '';
        $TablePrefix  = $oDb->getTablePrefix();
        $sql = 'SHOW FIELDS FROM `'.$TablePrefix.$table.'` ';
        if ($oRes = $oDb->query($sql)){
            while($aRes = $oRes->fetchRow(MYSQLI_ASSOC)){
              if (!isset($aExtraFields[$aRes['Field']])){continue;}
              $aTmp[$aRes['Field']] = $aExtraFields[$aRes['Field']];
              if (index_exists(TABLE_PREFIX.$table, $aRes['Field'])){
                  $aIndexField[] = $aRes['Field'].' = '.$aTmp[$aRes['Field']];
                  $iFirst++;
              }
            }
            $aExtraFieldsList =  \array_intersect_key($aTmp, $aExtraFields);
            foreach($aExtraFieldsList as $sName=>$sValue){
                $sExtraFields .= '`'.$sName.'` = \''.$sValue.'\', ';
            }
        } else {
            $retval[]=$sql;
            $retval[]=$oDb->get_error();
        }
        foreach( $key as $index=>$val)
        {
//            $index = strtolower($index);
            $sql  = 'SELECT COUNT(*) FROM `'.$TablePrefix.$table.'` '
                  . 'WHERE `s_name` = \''.$index.'\' '
                  . (!empty($aIndexField['0']) ? 'AND '. $aIndexField['0'] : '');
            if ($oDb->get_one($sql))
            {
                $sql = 'UPDATE ';
                $sql_where = 'WHERE `s_name` LIKE \''.$index.'\' ';
            } else {
                $sql = 'INSERT INTO ';
                $sql_where = '';
            }
            $sql .= '`'.$TablePrefix.$table.'` SET ';
            $sql .= (($sExtraFields) ? $sExtraFields : '');
            $sql .= '`s_name` = \''.$index.'\', ';
            $sql .= '`s_value` = \''.$val.'\' '.$sql_where;
            if (!$oDb->query($sql))
            {
                $retval[]=$sql;
                $retval[]=$oDb->get_error();
            }
        }
        return ((\count($retval)==0) ? true : $retval);
    };
}
#################################################################################

    $sModule = '
<script type="text/javascript">
var '.strtoupper($sAddonName).' = {
        ADMIN_DIRECTORY : "'.ADMIN_DIRECTORY.'",
        WB_URL : "'.$oReg->AppUrl.'",
        ADMIN_URL : "'.$oReg->AcpUrl.'",
        AddonUrl : "'.$sAddonUrl.'/",
        MODULE_THEME_URL : "'.$sAddonThemeUrl.'"
    };
    var ModulesCss = "'.$sAddonThemeUrl.'/css/default.css";
    if (typeof LazyOnLoad === \'undefined\'){
        $.insert(ModulesCss);
    } else {
        LazyOnLoad (\'head\', ModulesCss);
    }


</script>
';
    
    $aDefaults = [
        'section_id'            => (isset($section_id)?$section_id:'0'),
        'page_id'               => (isset($page_id)?$page_id:'0'),
        'show_header'           => '0',
        'show_headerdesc'       => '0',
        'show_footer'           => '0',
        'output_template'       => '1',
        'header'                => '',
        'footer'                => '',
        'headerdesc'            => '',
        'sort_cat_name'         => '2',
        'sort_quest_in_cats'    => '2',
        'use_keywords'          => '1',
        'use_glossar'           => '0',
        'use_wysiwyg'           => '1',
        'use_templates'         => '1',
        ];
    // set any defaults
    $sAddonName = basename($sAddonPath);
    $sAddonPath = $oReg->AppPath.'modules/'.$sAddonName;
    $sAddonUrl  = $oReg->AppUrl.'modules/'.$sAddonName;
    $sAddonRel = '/modules/'.$sAddonName;
    $aInstance = [
          'ADDON_NAME' => strtoupper($sAddonName),
          'ADMIN_DIRECTORY' => ADMIN_DIRECTORY,
          'AppUrl' =>  $oReg->AppUrl,
          'AcpUrl' =>  $oReg->AcpUrl,
          'sAddonUrl' => $sAddonUrl,
          'sAddonThemeUrl'  => $sAddonUrl.'/themes/default',
          'ModulesTemplateUrl' => ($bIsBackend?$sAddonThemeUrl:$sAddonTemplateUrl),
          'ADDON_URL'=> $sAddonUrl,
          'ModuleScript' => $sModule
          ];

// end of file

