<?php
/**
 * @category     Addons
 * @package      page module: faqbaker
 * @copyright    Uwe Jacobsen <webdesign@jacobi22.com>
 * @author       Uwe Jacobsen <webdesign@jacobi22.com>
 * @license      http://www.gnu.org/licenses/gpl.html   GPL License
 * @version      2.2.0
 * @lastmodified $Date: 2023/03/09
 * @since        File available since 2023/03/09
 * @description  addon faqbaker
 * glossar.template.inc
*/

###############################################################################
// read default template for import in add-process
###############################################################################
$sTemplateTitle = "Default Glossar Template";
$sTemplateDescription = "DESC_TEMPLATE_GLOSSARY";
$sTemplateCode = '
<div id="top_{{ setting.section_id }}" class="faq w3-padding-0 w3-container">
        {% if setting.header is not empty and setting.show_header == 1 %}
            <h2 class="w3-theme-l3 w3-row-padding header">{{ setting.header }}</h2>
        {% endif %}
        {% if setting.headerdesc is not empty and setting.show_headerdesc == 1 %}
            <p class="w3-row-padding headerdesc">{{ setting.headerdesc }}</p>
        {% endif %}
       
       
<div class="letters-bg">
{%  set foo =  range(\'A\',\'Z\') %}
{%  for letter in foo %}
    {% if letter in CatTitles %}
        <strong><a href="#letter-{{ letter|lower }}"><span class="w3-theme-color-d4">{{ letter|upper }}</span></a></strong>
    {% else %}
        <span class="w3-theme-color-l2">{{ letter|upper }}</span>
    {% endif %}
{% endfor %}
</div>        
        {% for cats in items %}
            <div class="w3-padding-0 w3-left-align">
                {# begin loop for cats #}
                    <div class="w3-left-align w3-padding-large" style="">
                        <h2 style="text-align:left !important; font-weight:bold;" class="letter" name="letter-{{ cats.cat_name|lower }}" id="letter-{{ cats.cat_name|lower }}">{{ cats.cat_name }}</h2>
                        {% for quest in cats.questions %}
                        <div id="quest{{ quest.question_id }}" class="quest w3-left-align w3-padding-8 w3-white dashed2" style="margin-bottom:15px;">
                            <button onclick="openAnswer(\'answer{{ quest.question_id}}\')" class="w3-button w3-block w3-left-align">{{ quest.question }}</button>
                            <div id="answer{{ quest.question_id }}" class="answer w3-container w3-hide w3-padding w3-theme-l5">
                                {{ quest.answer }}
                                <br>
                                <a href="#top_{{ setting.section_id }}">^ {{ lang.FQTEXT_GOTO_TOP }}</a>
                            </div>
                            
                        </div>
                        {% endfor %}
                    </div>
                {# end loop for cats #}
            </div>
        {% endfor %}
        {% if setting.footer is not empty and setting.show_footer == 1 %}
            <p class="footer w3-theme-l3 w3-row-padding">{{ setting.footer }}</p>
        {% endif %}
</div>
<script>
function openAnswer(id) {
    var x = document.getElementById(id);
    if (x.className.indexOf("w3-show") == -1) {
        x.className += " w3-show";
    } else {
        x.className = x.className.replace(" w3-show", "");
    }
}
</script>
';
