<?php
/**
 * @category     Addons
 * @package      page module: faqbaker
 * @copyright    Uwe Jacobsen <webdesign@jacobi22.com>
 * @author       Uwe Jacobsen <webdesign@jacobi22.com>
 * @license      http://www.gnu.org/licenses/gpl.html   GPL License
 * @version      2.2.0
 * @lastmodified $Date: 2023/03/09
 * @since        File available since 2023/03/09
 * @description  addon faqbaker
 *
 * search.php
/* -------------------------------------------------------- */
use addon\faqbaker\Lib\Faqbaker;
use bin\{WbAdaptor, SecureTokens};
use bin\helpers\{PreCheck};

//$oTrans->enableAddon('modules\\faqbaker');



function faqbaker_search($func_vars) {
    global $database;
        static $search_sql = '';
        \extract($func_vars, \EXTR_PREFIX_ALL, 'func');
        if (\function_exists('search_make_sql_part')) {
            if(empty($search_sql))
                $search_sql = search_make_sql_part($func_search_url_array, $func_search_match, ['`question`']);
        } else {
            $search_sql = '1=1';
        }

        // how many lines of excerpt we want to have at most
        $max_excerpt_num = $func_default_max_excerpt;
        $divider = ".";
        $result = false;
    
        $sql = 'SELECT `s_value` FROM `'.TABLE_PREFIX.'mod_faq_settings` '
              .'WHERE `s_name` = \'use_keywords\' '
              .'AND `section_id` = '.$func_section_id;
        $sUseKeywords = $database->get_one($sql);

        $sSql = 'SELECT `section_id`, `page_id`, `question_id`, `question`, `answer`, `keywords` '
             .  'FROM `'.TABLE_PREFIX.'mod_faq_questions` '
             .  'WHERE `section_id` = '.$func_section_id .' ';
        
        $query = $func_database->query($sSql);

        if ($query->numRows() > 0) {
            while ($res = $query->fetchAssoc()) {
                $sql = 'SELECT `link` FROM `'.TABLE_PREFIX.'pages` '
                      .'WHERE `page_id` = '.$res['page_id'].' ';
                $sPageLink = $database->get_one($sql);
                $sPermalink = WB_URL.PAGES_DIRECTORY.$sPageLink.PAGE_EXTENSION.'#quest'.$res['question_id'];
                
                    $itemdesc = "<div class=\"searchitemresults\">";
                    $itemdesc .= "<dl class=\"searchitems\">";
                    
                    if (($sUseKeywords == 1) && ($res['keywords'] != '')){
                        $itemdesc .= "<dt>Results:</dt>";
                        $itemdesc .= '<dd><a href="'.$sPermalink.'" target="_self">'.$res['keywords'].'</a></dd>';
                    }
                    $itemdesc .= "</dl>";
                    $itemdesc .= "</div>";
                    
                    $text = $itemdesc.$divider;

                $mod_vars = [
                    'page_link' => $func_page_link,
                    'page_link_target' => "",
                    'page_title' => $func_page_title,
                    'page_description' => $itemdesc,
//                    'page_modified_when' => $func_page_modified_when,
//                    'page_modified_by' => $func_page_modified_by,
                    'text' => $text,
                    'max_excerpt_num' => $max_excerpt_num
                ];


                if (print_excerpt2($mod_vars, $func_vars)) {
                    $result = true;
                }
            }
        }
        return $result;

}
